# openapi_client

OpenapiClient - the Ruby gem for the Microsoft Security Updates API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

This SDK is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: org.openapitools.codegen.languages.RubyClientCodegen

## Installation

### Build a gem

To build the Ruby code into a gem:

```shell
gem build openapi_client.gemspec
```

Then either install the gem locally:

```shell
gem install ./openapi_client-1.0.0.gem
```

(for development, run `gem install --dev ./openapi_client-1.0.0.gem` to install the development dependencies)

or publish the gem to a gem hosting service, e.g. [RubyGems](https://rubygems.org/).

Finally add this to the Gemfile:

    gem 'openapi_client', '~> 1.0.0'

### Install from Git

If the Ruby gem is hosted at a git repository: https:///YOUR_GIT_USERNAME/YOUR_GIT_REPO, then add the following in the Gemfile:

    gem 'openapi_client', :git => 'https:///YOUR_GIT_USERNAME/YOUR_GIT_REPO.git'

### Include the Ruby code directly

Include the Ruby code directly using `-I` as follows:

```shell
ruby -Ilib script.rb
```

## Getting Started

Please follow the [installation](#installation) procedure and then run the following code:

```ruby
# Load the gem
require 'openapi_client'

api_instance = OpenapiClient::DefaultApi.new
api_version = 'api_version_example' # String | 
api_key = 'api_key_example' # String | 
id = 'id_example' # String | 

begin
  result = api_instance.cvrf_id_get(api_version, api_key, id)
  p result
rescue OpenapiClient::ApiError => e
  puts "Exception when calling DefaultApi->cvrf_id_get: #{e}"
end

```

## Documentation for API Endpoints

All URIs are relative to *https://api.msrc.microsoft.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*OpenapiClient::DefaultApi* | [**cvrf_id_get**](docs/DefaultApi.md#cvrf_id_get) | **GET** /cvrf/{id} | 
*OpenapiClient::DefaultApi* | [**updates_get**](docs/DefaultApi.md#updates_get) | **GET** /Updates | 
*OpenapiClient::DefaultApi* | [**updates_id_get**](docs/DefaultApi.md#updates_id_get) | **GET** /Updates(&#39;{id}&#39;) | 


## Documentation for Models

 - [OpenapiClient::CvrfReturnTypes200](docs/CvrfReturnTypes200.md)
 - [OpenapiClient::CvrfReturnTypes200Acknowledgements](docs/CvrfReturnTypes200Acknowledgements.md)
 - [OpenapiClient::CvrfReturnTypes200AffectedFiles](docs/CvrfReturnTypes200AffectedFiles.md)
 - [OpenapiClient::CvrfReturnTypes200CVSSScoreSets](docs/CvrfReturnTypes200CVSSScoreSets.md)
 - [OpenapiClient::CvrfReturnTypes200DocumentNotes](docs/CvrfReturnTypes200DocumentNotes.md)
 - [OpenapiClient::CvrfReturnTypes200DocumentPublisher](docs/CvrfReturnTypes200DocumentPublisher.md)
 - [OpenapiClient::CvrfReturnTypes200DocumentTitle](docs/CvrfReturnTypes200DocumentTitle.md)
 - [OpenapiClient::CvrfReturnTypes200DocumentTracking](docs/CvrfReturnTypes200DocumentTracking.md)
 - [OpenapiClient::CvrfReturnTypes200DocumentTrackingIdentification](docs/CvrfReturnTypes200DocumentTrackingIdentification.md)
 - [OpenapiClient::CvrfReturnTypes200DocumentTrackingRevisionHistory](docs/CvrfReturnTypes200DocumentTrackingRevisionHistory.md)
 - [OpenapiClient::CvrfReturnTypes200Notes](docs/CvrfReturnTypes200Notes.md)
 - [OpenapiClient::CvrfReturnTypes200ProductStatuses](docs/CvrfReturnTypes200ProductStatuses.md)
 - [OpenapiClient::CvrfReturnTypes200ProductTree](docs/CvrfReturnTypes200ProductTree.md)
 - [OpenapiClient::CvrfReturnTypes200ProductTreeBranch](docs/CvrfReturnTypes200ProductTreeBranch.md)
 - [OpenapiClient::CvrfReturnTypes200ProductTreeItems](docs/CvrfReturnTypes200ProductTreeItems.md)
 - [OpenapiClient::CvrfReturnTypes200ProductTreeItems1](docs/CvrfReturnTypes200ProductTreeItems1.md)
 - [OpenapiClient::CvrfReturnTypes200Remediations](docs/CvrfReturnTypes200Remediations.md)
 - [OpenapiClient::CvrfReturnTypes200Threats](docs/CvrfReturnTypes200Threats.md)
 - [OpenapiClient::CvrfReturnTypes200Vulnerability](docs/CvrfReturnTypes200Vulnerability.md)
 - [OpenapiClient::CvrfReturnTypes200Xml](docs/CvrfReturnTypes200Xml.md)
 - [OpenapiClient::CvrfReturnTypes200XmlCvrfdoc](docs/CvrfReturnTypes200XmlCvrfdoc.md)
 - [OpenapiClient::CvrfReturnTypes200XmlCvrfdocDocumentNotes](docs/CvrfReturnTypes200XmlCvrfdocDocumentNotes.md)
 - [OpenapiClient::CvrfReturnTypes200XmlCvrfdocDocumentPublisher](docs/CvrfReturnTypes200XmlCvrfdocDocumentPublisher.md)
 - [OpenapiClient::CvrfReturnTypes200XmlCvrfdocDocumentTracking](docs/CvrfReturnTypes200XmlCvrfdocDocumentTracking.md)
 - [OpenapiClient::CvrfReturnTypes200XmlCvrfdocDocumentTrackingIdentification](docs/CvrfReturnTypes200XmlCvrfdocDocumentTrackingIdentification.md)
 - [OpenapiClient::CvrfReturnTypes200XmlCvrfdocDocumentTrackingRevisionHistory](docs/CvrfReturnTypes200XmlCvrfdocDocumentTrackingRevisionHistory.md)
 - [OpenapiClient::CvrfReturnTypes200XmlCvrfdocDocumentTrackingRevisionHistoryRevision](docs/CvrfReturnTypes200XmlCvrfdocDocumentTrackingRevisionHistoryRevision.md)
 - [OpenapiClient::CvrfReturnTypes200XmlCvrfdocNote](docs/CvrfReturnTypes200XmlCvrfdocNote.md)
 - [OpenapiClient::CvrfReturnTypes200XmlCvrfdocProductTree](docs/CvrfReturnTypes200XmlCvrfdocProductTree.md)
 - [OpenapiClient::CvrfReturnTypes200XmlCvrfdocProductTreeBranch](docs/CvrfReturnTypes200XmlCvrfdocProductTreeBranch.md)
 - [OpenapiClient::CvrfReturnTypes200XmlCvrfdocProductTreeBranch1](docs/CvrfReturnTypes200XmlCvrfdocProductTreeBranch1.md)
 - [OpenapiClient::CvrfReturnTypes200XmlCvrfdocProductTreeFullProductName](docs/CvrfReturnTypes200XmlCvrfdocProductTreeFullProductName.md)
 - [OpenapiClient::CvrfReturnTypes200XmlCvrfdocProductTreeFullProductName1](docs/CvrfReturnTypes200XmlCvrfdocProductTreeFullProductName1.md)
 - [OpenapiClient::CvrfReturnTypes200XmlCvrfdocVulnerability](docs/CvrfReturnTypes200XmlCvrfdocVulnerability.md)
 - [OpenapiClient::CvrfReturnTypes200XmlCvrfdocVulnerabilityAcknowledgements](docs/CvrfReturnTypes200XmlCvrfdocVulnerabilityAcknowledgements.md)
 - [OpenapiClient::CvrfReturnTypes200XmlCvrfdocVulnerabilityAffectedFiles](docs/CvrfReturnTypes200XmlCvrfdocVulnerabilityAffectedFiles.md)
 - [OpenapiClient::CvrfReturnTypes200XmlCvrfdocVulnerabilityCVSSScoreSets](docs/CvrfReturnTypes200XmlCvrfdocVulnerabilityCVSSScoreSets.md)
 - [OpenapiClient::CvrfReturnTypes200XmlCvrfdocVulnerabilityNotes](docs/CvrfReturnTypes200XmlCvrfdocVulnerabilityNotes.md)
 - [OpenapiClient::CvrfReturnTypes200XmlCvrfdocVulnerabilityNotesNote](docs/CvrfReturnTypes200XmlCvrfdocVulnerabilityNotesNote.md)
 - [OpenapiClient::CvrfReturnTypes200XmlCvrfdocVulnerabilityProductStatuses](docs/CvrfReturnTypes200XmlCvrfdocVulnerabilityProductStatuses.md)
 - [OpenapiClient::CvrfReturnTypes200XmlCvrfdocVulnerabilityRemediations](docs/CvrfReturnTypes200XmlCvrfdocVulnerabilityRemediations.md)
 - [OpenapiClient::CvrfReturnTypes200XmlCvrfdocVulnerabilityRevisionHistory](docs/CvrfReturnTypes200XmlCvrfdocVulnerabilityRevisionHistory.md)
 - [OpenapiClient::CvrfReturnTypes200XmlCvrfdocVulnerabilityThreat](docs/CvrfReturnTypes200XmlCvrfdocVulnerabilityThreat.md)
 - [OpenapiClient::CvrfReturnTypes200XmlCvrfdocVulnerabilityThreats](docs/CvrfReturnTypes200XmlCvrfdocVulnerabilityThreats.md)
 - [OpenapiClient::UpdatesReturnTypes200](docs/UpdatesReturnTypes200.md)
 - [OpenapiClient::UpdatesReturnTypes200Value](docs/UpdatesReturnTypes200Value.md)


## Documentation for Authorization

 All endpoints do not require authorization.

